/************************************************************************************/
/*  Program name CAPFAEXT_BOOKS.sql                                              	*/
/*  Creater:  NIP Karen (PCCW - UniHub)                                        		*/
/*************   History   *************************                                */
/* 21 DEC, 2005   NIP Karen         First created                               	*/
/************************************************************************************/
ALTER SESSION SET NLS_DATE_FORMAT='YYYYMMDD HH24:MI:SS';
SET SERVEROUTPUT ON SIZE 1000000;
SET VERIFY OFF

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPFAEXT_BOOKS';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	lv_FileName		VARCHAR2(100)	:=	'CAPFA_BOOKS.dat';
	lv_PathName		VARCHAR2(100)	:=	'/tmp';
	lv_UTL_File		UTL_FILE.File_Type;

	lv_NGO_Name		VARCHAR2(100);
	lv_NGO_Count	NUMBER;

	CURSOR Cur_F(p_NGO VARCHAR2) IS
	SELECT
		*
	FROM
		FA_BOOKS
	WHERE	SUBSTR(Book_Type_Code,1,4)	=	p_NGO;

BEGIN
	lv_NGO_Name		:=	UPPER('&1');

	SELECT	COUNT('A')
	INTO	lv_NGO_Count
	FROM	HR_ALL_ORGANIZATION_UNITS
	WHERE	SUBSTR(Name,4,4)	=	lv_NGO_Name;

	IF	lv_NGO_Count	>=	1	THEN
		lv_UTL_File		:=	UTL_FILE.FOpen(lv_PathName, lv_FileName, 'w');
		FOR C1 IN Cur_F(lv_NGO_Name) LOOP
			UTL_FILE.PUT_LINE(
				lv_UTL_File,
				C1.BOOK_TYPE_CODE||CHR(9)||
				C1.ASSET_ID||CHR(9)||
        		C1.DATE_PLACED_IN_SERVICE||CHR(9)||
        		C1.DATE_EFFECTIVE||CHR(9)||
        		C1.DEPRN_START_DATE||CHR(9)||
        		C1.DEPRN_METHOD_CODE||CHR(9)||
        		C1.LIFE_IN_MONTHS||CHR(9)||
        		C1.RATE_ADJUSTMENT_FACTOR||CHR(9)||
        		C1.ADJUSTED_COST||CHR(9)||
        		C1.COST||CHR(9)||
        		C1.ORIGINAL_COST||CHR(9)||
        		C1.SALVAGE_VALUE||CHR(9)||
        		C1.PRORATE_CONVENTION_CODE||CHR(9)||
        		C1.PRORATE_DATE||CHR(9)||
        		C1.COST_CHANGE_FLAG||CHR(9)||
        		C1.ADJUSTMENT_REQUIRED_STATUS||CHR(9)||
        		C1.CAPITALIZE_FLAG||CHR(9)||
        		C1.RETIREMENT_PENDING_FLAG||CHR(9)||
        		C1.DEPRECIATE_FLAG||CHR(9)||
        		C1.LAST_UPDATE_DATE||CHR(9)||
        		C1.LAST_UPDATED_BY||CHR(9)||
        		C1.DATE_INEFFECTIVE||CHR(9)||
        		C1.TRANSACTION_HEADER_ID_IN||CHR(9)||
        		C1.TRANSACTION_HEADER_ID_OUT||CHR(9)||
        		C1.ITC_AMOUNT_ID||CHR(9)||
        		C1.ITC_AMOUNT||CHR(9)||
        		C1.RETIREMENT_ID||CHR(9)||
        		C1.TAX_REQUEST_ID||CHR(9)||
        		C1.ITC_BASIS||CHR(9)||
        		C1.BASIC_RATE||CHR(9)||
        		C1.ADJUSTED_RATE||CHR(9)||
        		C1.BONUS_RULE||CHR(9)||
        		C1.CEILING_NAME||CHR(9)||
        		C1.RECOVERABLE_COST||CHR(9)||
        		C1.LAST_UPDATE_LOGIN||CHR(9)||
        		C1.ADJUSTED_CAPACITY||CHR(9)||
        		C1.FULLY_RSVD_REVALS_COUNTER||CHR(9)||
        		C1.IDLED_FLAG||CHR(9)||
        		C1.PERIOD_COUNTER_CAPITALIZED||CHR(9)||
        		C1.PERIOD_COUNTER_FULLY_RESERVED||CHR(9)||
        		C1.PERIOD_COUNTER_FULLY_RETIRED||CHR(9)||
        		C1.PRODUCTION_CAPACITY||CHR(9)||
        		C1.REVAL_AMORTIZATION_BASIS||CHR(9)||
        		C1.REVAL_CEILING||CHR(9)||
        		C1.UNIT_OF_MEASURE||CHR(9)||
        		C1.UNREVALUED_COST||CHR(9)||
        		C1.ANNUAL_DEPRN_ROUNDING_FLAG||CHR(9)||
        		C1.PERCENT_SALVAGE_VALUE||CHR(9)||
        		C1.ALLOWED_DEPRN_LIMIT||CHR(9)||
        		C1.ALLOWED_DEPRN_LIMIT_AMOUNT||CHR(9)||
        		C1.PERIOD_COUNTER_LIFE_COMPLETE||CHR(9)||
        		C1.ADJUSTED_RECOVERABLE_COST||CHR(9)||
        		C1.ANNUAL_ROUNDING_FLAG||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE1||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE2||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE3||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE4||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE5||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE6||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE7||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE8||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE9||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE10||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE11||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE12||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE13||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE14||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE15||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE16||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE17||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE18||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE19||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE20||CHR(9)||
        		C1.GLOBAL_ATTRIBUTE_CATEGORY||CHR(9)||
        		C1.EOFY_ADJ_COST||CHR(9)||
        		C1.EOFY_FORMULA_FACTOR||CHR(9)||
        		C1.SHORT_FISCAL_YEAR_FLAG||CHR(9)||
        		C1.CONVERSION_DATE||CHR(9)||
        		C1.ORIGINAL_DEPRN_START_DATE||CHR(9)||
        		C1.REMAINING_LIFE1||CHR(9)||
        		C1.REMAINING_LIFE2||CHR(9)||
        		C1.OLD_ADJUSTED_COST||CHR(9)||
        		C1.FORMULA_FACTOR||CHR(9)||
        		C1.GROUP_ASSET_ID||CHR(9)||
        		CAPBREXT_COMMON.GetUser(C1.LAST_UPDATED_BY)
			);

			lv_Scc_Count	:=	lv_Scc_Count	+	1;
		END LOOP;
		UTL_FILE.FClose(lv_UTL_File);
	ELSE
		lv_Err_Count	:=	lv_Err_Count + 1;
		lv_Err_Msg		:=	lv_NGO_Name||': No such NGO exists';
	END IF;

	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);

	COMMIT;
END;
/
